package si.mojeznanje.model;

import com.fasterxml.jackson.annotation.JsonIgnore;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class Ograda {

    private ArrayList<Zival> zivali = new ArrayList<Zival>();
    private List<Pes> psi = new ArrayList<Pes>();
    private List<Macka> macke = new ArrayList<Macka>();
    private List<Riba> ribe = new ArrayList<Riba>();

    private Date datumOdprtja;

    public Ograda() {
        datumOdprtja = new Date();
        System.out.println(datumOdprtja.toString() + " odprli smo novo ogrado!");
    }

    @JsonIgnore
    public List<Zival> getZivali(){
        return zivali;
    }

    public List<Pes> getPsi() {
        return psi;
    }

    public void setPsi(List<Pes> psi) {
        this.psi = psi;
        zivali.addAll(psi);
    }

    public List<Macka> getMacke() {
        return macke;
    }

    public void setMacke(List<Macka> macke) {
        this.macke = macke;
        zivali.addAll(macke);
    }

    public List<Riba> getRibe() {
        return ribe;
    }

    public void setRibe(List<Riba> ribe) {
        this.ribe = ribe;
        zivali.addAll(ribe);
    }

    public Date getDatumOdprtja() {
        return datumOdprtja;
    }

    public void setDatumOdprtja(Date datumOdprtja) {
        this.datumOdprtja = datumOdprtja;
    }

    public void dodajZival(Zival novaZival) {
        Boolean novaZivalJeEnaka = false;

        for(Zival staraZival : this.zivali)
        {
            if(staraZival.equals(novaZival))
            {
                System.out.println(novaZival.getIme() + " je ze v ogradi!");
                novaZivalJeEnaka = true;
            }
        }

        if(!novaZivalJeEnaka)
        {
            this.zivali.add(novaZival);

            if(novaZival instanceof Pes){
                psi.add((Pes)novaZival);
            }
            else if(novaZival instanceof Macka){
                macke.add((Macka) novaZival);
            }
            else if(novaZival instanceof Riba){
                ribe.add((Riba) novaZival);
            }
        }
    }

    public void dodajZivali(List<Zival> zivali) {

        for (Zival novaZival : zivali)
        {
            dodajZival(novaZival);
        }

        System.out.println(zivali.size() + " je dodanih v ogrado.");
    }

    public void izipisiVseZivali() {
        System.out.println("V ogradi je " + zivali.size() + " zivali.");

        if (zivali.size() > 0) {

            for (Zival zival : zivali) {
                System.out.println(zival.toString());
            }
        }
    }

    public Float vrniPovprecnoStarostZivaliVOgradi()
    {
        Integer[] starosti = new Integer[zivali.size()];

        for(int i = 0; i < zivali.size(); i++){
            starosti[i] = zivali.get(i).getStarost();
        }
        Float povprecnaStarost = Ograda.izracunajPovprecnoStarost(starosti);

        return povprecnaStarost;

    }

    public static Float izracunajPovprecnoStarost(Integer[] starosti){

        Float povprecnaStarost = 0f;
        Float skupekStarosti = 0f;

        for(int i = 0; i < starosti.length; i++){
            Integer starost = starosti[i];
            skupekStarosti = skupekStarosti + starost;
        }

        povprecnaStarost = skupekStarosti / starosti.length;

        return povprecnaStarost;
    }

}
