package si.mojeznanje.services;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import si.mojeznanje.model.Zival;

import java.util.ArrayList;
import java.util.List;

public class ZapisovalecPodatkovJson extends ZapisovalecZivali {

    private static final String datoteka = "zivali.json";

    @Override
    public void shraniZivali(List<Zival> zivali){

        String podatki = "";
        ObjectMapper mapper = new ObjectMapper();
        mapper.enableDefaultTyping(ObjectMapper.DefaultTyping.OBJECT_AND_NON_CONCRETE);

        try {
            podatki = mapper.writeValueAsString(zivali);
        }
        catch (Exception e){
            System.out.println("Napaka pri pretvorbi podatkov v string");
        }

        shraniDatoteko(podatki, datoteka);
    }

    @Override
    public List<Zival> pridobiZivali(){
      List<Zival> zivali = new ArrayList<>();

      String podatki = preberiPodatke(datoteka);

      ObjectMapper mapper = new ObjectMapper();
      mapper.enableDefaultTyping(ObjectMapper.DefaultTyping.NON_CONCRETE_AND_ARRAYS);

      try {
          zivali = mapper.readValue(podatki, new TypeReference<List<Zival>>(){});
      }
      catch (Exception e){
          System.out.println("Napaka pri branju podatkov");
      }

      return zivali;
    }
}
