package si.mojeznanje.services;

import si.mojeznanje.model.Zival;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class ZapisovalecZivali extends Zapisovalec {

    private static final String datoteka = "zivali.txt";

    public void shraniZivali(List<Zival> zivali){
        String podatki = "";

        for(Zival zival : zivali){
            podatki += zival.toCSV()+System.lineSeparator();
        }

        shraniDatoteko(podatki, datoteka);
    }
    public List<Zival> pridobiZivali(){
        List<Zival> zivali = new ArrayList<Zival>();

        String podatki = preberiPodatke(datoteka);

        String[] vrstice = podatki.split(System.lineSeparator());

        for(String vrstica : vrstice){

            Zival zival = ustvariZivalIzVrstice(vrstica);

            if(zival != null){
                zivali.add(zival);
            }
        }

        return zivali;
    }

    private static Zival ustvariZivalIzVrstice(String vrstica){

        Zival zival = null;

        String[] vrednosti = vrstica.split(",");

        try {
            Class razredZivali = Class.forName(vrednosti[0]);
            zival = (Zival) razredZivali.newInstance();

            zival.setIme(vrednosti[1]);
            zival.setStarost(Integer.parseInt(vrednosti[2]));
            zival.setSpol(Integer.parseInt(vrednosti[3]));
        }
        catch (Exception e){
            System.out.println("Napaka pri ustvaranju nove instance zivali!");
            return null;
        }

        return zival;
    }


    private static void shraniDatotekoDolga(String podatki, String datoteka){
        BufferedWriter writer = null;

        try {
            writer = new BufferedWriter(new FileWriter(datoteka));
            writer.write(podatki);
        }
        catch (Exception exception){
            System.out.println("Napaka pri pisanju datoteke");
        }
        finally {
            try {
                writer.close();
            }
            catch (Exception e){

            }

        }
    }
}
